// PluginTemplateCpp.h

#pragma once

using namespace System;
using namespace VVVV::PluginInterfaces::V1;

namespace PluginTemplateCpp {

	public ref class TemplateCpp :IPlugin
	{
		private:
			IValueIn^ vInValue;
			IValueOut^ vOutValue;
			IPluginHost^ FHost;

		public:
			TemplateCpp() { }
			~TemplateCpp() { }

			static property IPluginInfo^ PluginInfo 
			{
				IPluginInfo^ get() 
				{
					//IPluginInfo^ Info;
					IPluginInfo^ Info = gcnew VVVV::PluginInterfaces::V1::PluginInfo();
					Info->Name = "TemplateCpp";
					Info->Category = "Samples";
					Info->Version = "";
					Info->Help = "Sample Template in C++";
					Info->Bugs = "";
					Info->Credits = "";
					Info->Warnings = "";

					//leave below as is
					System::Diagnostics::StackTrace^ st = gcnew System::Diagnostics::StackTrace(true);
					System::Diagnostics::StackFrame^ sf = st->GetFrame(0);
					System::Reflection::MethodBase^ method = sf->GetMethod();
					Info->Namespace = method->DeclaringType->Namespace;
					Info->Class = method->DeclaringType->Name;
					return Info;
				}
			}
			virtual void SetPluginHost(IPluginHost^ Host);
			virtual void Configurate(IPluginConfig^ Input);
			virtual void Evaluate(int SpreadMax);
			
			virtual property bool AutoEvaluate {
				bool get() { return false; }
			}


	};
}
